package com.atomicriot.pinacoladaxb.HideAndSeek;

import java.io.File;
import java.util.List;

import org.bukkit.util.config.Configuration;


public class Config {
    private final HideAndSeek plugin;
    public Config(HideAndSeek instance) {
        this.plugin = instance;
    }
       
       
    public void configCheck(){
    	String directory = "plugins" + File.separator +plugin.getDescription().getName();
        File file = new File(directory + File.separator + "config.yml");
        new File(directory).mkdir();

        if(!file.exists()){
            try {
                file.createNewFile();
                addDefaults();

            } catch (Exception ex) {
                ex.printStackTrace();
            }
        } else {

            loadkeys();
        }
    }
    public void write(String root, Object x){
        Configuration config = load();
        config.setProperty(root, x);
        config.save();
    }
    public Boolean readBoolean(String root){
        Configuration config = load();
        return config.getBoolean(root, true);
    }
    public Double readDouble(String root){
        Configuration config = load();
        return config.getDouble(root, 0);
    }
    public List<String> readStringList(String root){
        Configuration config = load();
        return config.getKeys(root);
    }
    public String readString(String root){
        Configuration config = load();
        return config.getString(root);
    }
    public Configuration load(){
    	String directory = "plugins" + File.separator +plugin.getDescription().getName();
        File file = new File(directory + File.separator + "config.yml");
        try {
            Configuration config = new Configuration(file);
            config.load();
            return config;

        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }
    public void addDefaults(){
    	plugin.log("Generating Config File...");
    	write("safe1","-7,37,9");
    	write("safe2","7,32,-5");
    	write("count1","-1,28,1");
    	write("count2","1,26,3");
    	write("dq1","-21,26,23");
    	write("dq2","21,127,-19");
    	write("specialCase","1");
    	loadkeys();
    }
    public void loadkeys(){
        plugin.log("Loading Config File...");
        String[] safe1 = readString("safe1").split(",");
        String[] safe2 = readString("safe2").split(",");
        String[] count1 = readString("count1").split(",");
        String[] count2 = readString("count2").split(",");     
        String[] dq1 = readString("dq1").split(",");
        String[] dq2 = readString("dq2").split(",");    
        plugin.safe1 = stringToInt(safe1);
        plugin.safe2 = stringToInt(safe2);
        plugin.count1 = stringToInt(count1);
        plugin.count2 = stringToInt(count2);
        plugin.dq1 = stringToInt(dq1);
        plugin.dq2 = stringToInt(dq2);
        plugin.specialCase = Integer.parseInt(readString("specialCase"));
        //TODO: Configure messages
    }
    public int[] stringToInt(String[] source) {
    	int[] returnInt = new int[3];
    	for(int i=0;i<3;i++) {
    		returnInt[i] = Integer.parseInt(source[i]);
    	}
		return returnInt;
    }
}