package com.atomicriot.pinacoladaxb.HideAndSeek;

import java.util.ArrayList;
import java.util.Arrays;

import org.bukkit.block.Block;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.World;
import org.bukkit.event.Event.Priority;
import org.bukkit.event.Event;
import org.bukkit.plugin.Plugin;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.plugin.PluginManager;

import com.nijiko.permissions.PermissionHandler;
import com.nijikokun.bukkit.Permissions.Permissions;

/**
 * HideAndSeek for Bukkit
 *
 * @author pinacoladaxb
 */

/*
 * Nodes:
 * HideAndSeek.op
 */

//NOTE: There seems to be an instancing problem. Temp fix is making gameState static

public class HideAndSeek extends JavaPlugin {
    private final HideAndSeekPlayerListener playerListener = new HideAndSeekPlayerListener(this);
    private final HideAndSeekBlockListener blockListener = new HideAndSeekBlockListener(this);
    private final HideAndSeekEntityListener entityListener = new HideAndSeekEntityListener(this);
	    
	PermissionHandler permissions;
	private boolean usePermissions;
	
	ArrayList<Player> players = new ArrayList<Player>();
	ArrayList<Integer> playerStates = new ArrayList<Integer>();// 0=uncaught;1=safe;2=caught;3=seeker
	ArrayList<Integer> wins = new ArrayList<Integer>();
	int gameState = 0; // 0=pregame;1=hiding;2=seeking
	Player seeker;
	Player nextSeeker;
	int[] safe1;
	int[] safe2;
	int[] count1;
	int[] count2;
	int[] dq1;
	int[] dq2;
	int specialCase = 0; //0=nothing, 1=hide and seek with David
	Boolean pvp; // server's default pvp setting
	Player winner;
	
	private final Config config = new Config(this);

    public void onEnable() {

    	// Register events
		PluginManager pm = getServer().getPluginManager();
		pm.registerEvent(Event.Type.PLAYER_MOVE, playerListener, Priority.Low, this); // Player in safe or counting zone
		pm.registerEvent(Event.Type.PLAYER_JOIN, playerListener, Priority.Normal, this); // Exclude from current round
		pm.registerEvent(Event.Type.PLAYER_QUIT, playerListener, Priority.Normal, this); // Remove from current round and check		
		pm.registerEvent(Event.Type.PLAYER_RESPAWN, playerListener, Priority.Normal, this); // DQ player on death
		pm.registerEvent(Event.Type.ENTITY_DAMAGE, entityListener, Priority.Normal, this); // See if seeker found player
		pm.registerEvent(Event.Type.BLOCK_PLACE, blockListener, Priority.Normal, this); // Cancel event during round
		pm.registerEvent(Event.Type.BLOCK_BREAK, blockListener, Priority.Normal, this); // Cancel event during round
		
		//TODO: Remove these from official release:
		if (specialCase==1) {
			pm.registerEvent(Event.Type.BLOCK_DAMAGE, blockListener, Priority.Normal, this); // REMOVE
			pm.registerEvent(Event.Type.ITEM_SPAWN, entityListener, Priority.Normal, this); // REMOVE
		}
		//TODO: pm.registerEvent(Event.Type.INVENTORY_CHANGE, inventoryListener, Priority.Normal, this); // REMOVE

		// Console enable message
		log("Version " + this.getDescription().getVersion() + " enabled");

		// Set up crap
		setupPermissions();
		config.configCheck();
		this.pvp = this.getServer().getWorlds().get(0).getPVP();
		this.getServer().getWorlds().get(0).setPVP(true);
    }
    
    public void onDisable() {
    	// Disable crap
    	this.getServer().getWorlds().get(0).setPVP(this.pvp);
    	
    	// Console disable message
		log("Version " + this.getDescription().getVersion() + " disabled");
    }
    
    public String getUsage(String cmd) {
    	if (cmd.equalsIgnoreCase("newgame")) {
    		return "Correct usage: /newgame <player>";
    	}
    	if (cmd.equalsIgnoreCase("endgame")) {
    		return "Correct usage: /endgame";
    	}
    	return "Incorrect usage";
    }
    
    public void log(String message) {
		System.out.println("["+this.getDescription().getName() + "] " + message);
	}
    
    public void broadcast(String message) {
    	this.getServer().broadcastMessage(this.getDescription().getName() + ": " + message);
    }
    
	private void setupPermissions() {
		Plugin test = this.getServer().getPluginManager().getPlugin("Permissions");
		if (this.permissions == null) {
			if (test != null) {
				this.usePermissions = true;
				this.permissions = ((Permissions) test).getHandler();
				log("Permissions enabled");
			} else {
				log("Permission system not detected, defaulting to OP");
				this.usePermissions = false;
			}
		}
	}
	
	public boolean canUse(Player player, String node) {
		if (usePermissions) {
			return this.permissions.has(player, node);
		}
		return player.isOp();
	}
	
	// Clear arrays (losing player and safe data) and add players with state 0
	public void refreshPlayers() {
		this.players.clear();
		this.playerStates.clear();
		for (Player p : this.getServer().getOnlinePlayers()) {
			this.players.add(p);
			this.playerStates.add(0);
			this.wins.add(0);
		}
	}
	
	//Counts players in array with desired state
	public int countStates(int query) {
		int players=0;
		for(int state:this.playerStates) {
			if(state==query) {
				players++;
			}
		}
		return players;
	}
	
	public void setState(Player player, int state) {
		if(!(this.players.contains(player))) {
			return; // Ignore if player is not in array
		}
		this.playerStates.set(this.players.indexOf(player), state);
	}
	
	public int getState(Player player) {
		if(!(this.players.contains(player))) {
			return 1; // Claim player is safe if not in array
		}
		return this.playerStates.get(this.players.indexOf(player));
	}
	
	public void nextRound() {
		this.seeker.setCompassTarget(this.getServer().getWorlds().get(0).getSpawnLocation());
		gameState = 0; //hey0
		if(nextSeeker==null) {
			this.seeker = this.players.get((int)(Math.random() * (this.players.size())));
			this.nextSeeker = this.seeker;
		} else {
			this.seeker = this.nextSeeker;
		}
		setState(seeker,3);
    	this.winner = this.getWinner();
		broadcast(ChatColor.GREEN+"New Round ("+ChatColor.AQUA+this.winner.getName()+ChatColor.GREEN+" is winning)");
		broadcast(ChatColor.RED+this.seeker.getName()+ChatColor.GREEN+" is the seeker");
		log("New Round");
		log(this.seeker.getName()+" is the seeker");
	}
	
	public boolean isInBounds(Location location, int[] corner1, int[] corner2) {
		int[] xArray = {location.getBlockX(), corner1[0], corner2[0]};
		int[] yArray = {location.getBlockY(), corner1[1], corner2[1]};
		int[] zArray = {location.getBlockZ(), corner1[2], corner2[2]};
		Arrays.sort(xArray);
		Arrays.sort(yArray);
		Arrays.sort(zArray);
		if(xArray[1]==location.getBlockX() && yArray[1]==location.getBlockY() && zArray[1]==location.getBlockZ()) {
			return true;
		}
		return false;
	}
	
	public Player getWinner() {
		int winsNum = 0;
    	int index = 0;
    	int indexTemp = 0;
    	for(int i:this.wins) {
    		if(i>winsNum) {
    			winsNum=i;
    			index=indexTemp;
    		}
    		indexTemp++;
    	}
    	return this.players.get(index);
	}
	
	public Player getWinner(Player player) {
		int winsNum = 0;
    	int index = 0;
    	int indexTemp = 0;
    	for(int i:this.wins) {
    		if(i>winsNum && this.players.get(indexTemp)!=player) {
    			winsNum=i;
    			index=indexTemp;
    		}
    		indexTemp++;
    	}
    	return this.players.get(index);
	}
	
	public void reset() {
		gameState = 0; //hey0
		this.players.clear();
		this.playerStates.clear();
		this.wins.clear();
		this.seeker = null;
		this.nextSeeker = null;
	}
	
	public void setWin(Player player, int increment) {
		this.wins.set(this.players.indexOf(player), this.wins.get(this.players.indexOf(player))+increment);

	}
	
	public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
		Player player = null;
		String commandText = command.getName().toLowerCase();
		boolean isPlayer = Boolean.valueOf(sender instanceof Player);
		if (isPlayer) {
			player = (Player) sender;
		}

		// newgame
		if (commandText.equals("newgame")) {
			Player target = null;
			if (isPlayer && !canUse(player, "HideAndSeek.op")) {
				return false;
			}
			if (args.length > 1) {
				if(isPlayer) {
					player.sendMessage(ChatColor.GRAY+getUsage("newgame"));
				} else {
					log(getUsage("newgame"));
				}
				return true;
			}
			refreshPlayers();
			if(this.players.size()==0) {
				if(isPlayer) {
					player.sendMessage(ChatColor.GRAY + "There are no players online...wait...how are you here then? PARADOX! Tell pinacoladaxb!");
				} else {
					log("There are no players online");
				}
				return true;
			}
			if (args.length == 0) {
				target = this.players.get((int)(Math.random() * (this.players.size())));
			}
			if (args.length == 1) {
				target = this.getServer().getPlayer(args[0]);
				if(target == null) {
					if(isPlayer) {
						player.sendMessage(ChatColor.GRAY + "Target player is not online");
					} else {
						log("Target player is not online");
					}
					return true;
				}
			}
			gameState = 0; //hey0
			this.seeker = target;
			this.nextSeeker = target;
			setState(target,3);
			if(isPlayer) {
				broadcast(ChatColor.AQUA + player.getName() + ChatColor.GREEN + " has started a new game");
				log(player.getName()+ " has started a new game");
			} else {
				broadcast(ChatColor.GREEN + "A new game has been started");
				log("A new game has been started");
			}
			broadcast(ChatColor.RED + target.getName() + ChatColor.GREEN + " is the seeker");
			log(target.getName() + " is the seeker");
			return true;
		}
		
		// endgame
		if (commandText.equals("endgame")) {
			if(isPlayer) {
				if(!canUse(player, "HideAndSeek.op")) {
					return false;
				}
				if(this.players.isEmpty()) {
					player.sendMessage(ChatColor.GRAY+"There is no hide-and-seek game running");
					return true;
				}
				broadcast(ChatColor.AQUA + player.getName() + ChatColor.GREEN + " has ended the game");
				log(player.getName() + " has ended the game");
			} else {
				if(this.players.isEmpty()) {
					log("There is no hide-and-seek game running");
					return true;
				}
				broadcast(ChatColor.GREEN + "The game has ended");
				log("The game has ended");
			}
			reset();
			return true;
		}
		//TODO: Add commands for in-game boundary setup
		
		// setsafety
		if (commandText.equals("setsafety")) {
		}
		
		// setcounting
		if (commandText.equals("setcounting")) {
		}
		
		//hsdebug
		//TODO: REMOVE
		if (commandText.equals("hsdebug")) {
			if(!isPlayer && args.length==0) {
				String playersDebug = null;
				if(this.players.size()>0) {
					playersDebug = "";
					for (int i=0; i<this.players.size(); i++) {
						playersDebug += this.players.get(i).getName()+" ("+this.playerStates.get(i)+", "+this.wins.get(i)+")";
						if(i<this.players.size()-1) {
							playersDebug += ", ";
						}
					}
				}
				String safe1str = "";
				String safe2str = "";
				String count1str = "";
				String count2str = "";
				String dq1str = "";
				String dq2str = "";
				for (int i=0;i<3;i++) {
					safe1str+=Integer.toString(this.safe1[i]);
					safe2str+=Integer.toString(this.safe2[i]);
					count1str+=Integer.toString(this.count1[i]);
					count2str+=Integer.toString(this.count2[i]);
					dq1str+=Integer.toString(this.dq1[i]);
					dq2str+=Integer.toString(this.dq2[i]);
					if(i<2) {
						safe1str+=",";
						safe2str+=",";
						count1str+=",";
						count2str+=",";
						dq1str+=",";
						dq2str+=",";
					}
				}
				log("Players: "+playersDebug);
				log("Game State: "+this.gameState);
				if(this.seeker!=null) {
					log("Seeker: "+this.seeker.getName());
				} else {
					log("Seeker: "+this.seeker);
				}
				if(this.nextSeeker!=null) {
					log("Next Seeker: "+this.nextSeeker.getName());
				} else {
					log("Next Seeker: "+this.nextSeeker);
				}
				if(winner != null) {
					log("Winner: "+winner.getName());
				} else {
					log("Winner: null");
				}
				log("PVP Default: "+this.pvp);
				log("Safe1: "+safe1str);
				log("Safe2: "+safe2str);
				log("Count1: "+count1str);
				log("Count2: "+count2str);
				log("Disqualified1: "+dq1str);
				log("Disqualified2: "+dq2str);
			} else if(args.length>1) {
				String returnMessage = "";
				if(args[0].equalsIgnoreCase("players")) {
					if(args.length==3) {
						int index = 0;
						try {
							index = Integer.parseInt(args[1]);
						} catch (Exception e) {
							return false;
						}
						if(this.getServer().getPlayer(args[2]) != null) {
							try {
								players.set(index, this.getServer().getPlayer(args[2]));
							} catch (IndexOutOfBoundsException e) {
								return false;
							}
							returnMessage = "Set players["+index+"] to "+players.get(index).getName();
						} else {
							return false;
						}
					}
				} else if(args[0].equalsIgnoreCase("playerStates")) {
					if(args.length==3) {
						int index = 0;
						int newState = 0;
						try {
							newState = Integer.parseInt(args[2]);
						} catch (Exception e) {
							return false;
						}
						if(players.contains(this.getServer().getPlayer(args[1]))) {
							try {
								playerStates.set(players.indexOf(this.getServer().getPlayer(args[1])), newState);
							} catch (IndexOutOfBoundsException e) {
								return false;
							}
							returnMessage = "Set "+ this.getServer().getPlayer(args[1]).getName()+"'s state to "+newState;
						} else {
							try {
								index = Integer.parseInt(args[1]);
							} catch (Exception e) {
								return false;
							}
							try {
								playerStates.set(index, newState);
							} catch (IndexOutOfBoundsException e) {
								return false;
							}
							returnMessage = "Set playerStates["+index+"] to "+newState;
						}
					}
				} else if(args[0].equalsIgnoreCase("wins")) {
					if(args.length==3) {
						int index = 0;
						int newWins = 0;
						try {
							newWins = Integer.parseInt(args[2]);
						} catch (Exception e) {
							return false;
						}
						if(players.contains(this.getServer().getPlayer(args[1]))) {
							try {
								wins.set(players.indexOf(this.getServer().getPlayer(args[1])), newWins);
							} catch (IndexOutOfBoundsException e) {
								return false;
							}
							returnMessage = "Set "+ this.getServer().getPlayer(args[1]).getName()+"'s wins to "+newWins;
						} else {
							try {
								index = Integer.parseInt(args[1]);
							} catch (Exception e) {
								return false;
							}
							try{
								wins.set(index, newWins);
							} catch (IndexOutOfBoundsException e) {
								return false;
							}
							returnMessage = "Set wins["+index+"] to "+newWins;
						}
					}
				} else if(args[0].equalsIgnoreCase("gameState")) {
					int newGameState = 0;
					try {
						newGameState = Integer.parseInt(args[1]);
					} catch (Exception e) {
						return false;
					}
					gameState = newGameState;
					returnMessage = "Set gameState to "+gameState;
				} else if(args[0].equalsIgnoreCase("seeker")) {
					if(this.getServer().getPlayer(args[1]) != null) {
						seeker = this.getServer().getPlayer(args[1]);
						returnMessage = "Set seeker to "+seeker.getName();
					} else {
						return false;
					}
				} else if(args[0].equalsIgnoreCase("nextSeeker")) {
					if(this.getServer().getPlayer(args[1]) != null) {
						nextSeeker = this.getServer().getPlayer(args[1]);
						returnMessage = "Set nextSeeker to "+nextSeeker.getName();
					} else {
						return false;
					}
				} else if(args[0].equalsIgnoreCase("pvp")) {
					if(args[1].equalsIgnoreCase("true")) {
						pvp = true;
						returnMessage = "Set pvp to true";
					} else if(args[1].equalsIgnoreCase("false")) {
						pvp = false;
						returnMessage = "Set pvp to false";
					} else {
						return false;
					}
				} else if(args[0].equalsIgnoreCase("winner")) {
					if(this.getServer().getPlayer(args[1]) != null) {
						winner = this.getServer().getPlayer(args[1]);
						returnMessage = "Set winner to "+winner.getName();
					} else {
						return false;
					}
				}
				if(isPlayer) {
					player.sendMessage("HideAndSeek: "+ChatColor.GRAY+returnMessage);
					log(player.getName()+" "+returnMessage);
				} else {
					log(returnMessage);
				}
				return true;
			} else {
				return false;
			}
		}
		
		//wipe TODO: REMOVE THIS COMMAND
		if (commandText.equals("wipe")) {
			if(isPlayer) {
				player.getInventory().clear();
			}
		}
		
		//platenew TODO: REMOVE THIS COMMAND
		if (commandText.equals("platenew")) {
			if (specialCase==1) {
				Thread t;
				if(isPlayer) {
					t = new Thread(new ActivateRedstone("plate", player.getWorld().getBlockAt(-15, 26, 635)));
				} else {
					t = new Thread(new ActivateRedstone("plate", this.getServer().getWorlds().get(0).getBlockAt(-15, 26, 635)));
				}
				t.start();
				broadcast(ChatColor.GRAY+"Simulated new game plates");
				log("Simulated new game plates");
				return true;
			} else {
				return false;
			}
		}
		
		//plateseek TODO: REMOVE THIS COMMAND
		if (commandText.equals("plateseek")) {
			if (specialCase==1) {
				Thread t;
				if(isPlayer) {
					t = new Thread(new ActivateRedstone("plate", player.getWorld().getBlockAt(-16, 23, 626)));
				} else {
					t = new Thread(new ActivateRedstone("plate", this.getServer().getWorlds().get(0).getBlockAt(-16, 23, 626)));
				}
				t.start();
				broadcast(ChatColor.GRAY+"Simulated seeker plates");
				log("Simulated seeker plates");
				return true;
			} else {
				return false;
			}
		}
		
		//door TODO: REMOVE THIS COMMAND
		if (commandText.equals("door")) {
			if (specialCase==1) {
				if(args.length==1) {
					Thread t;
					if(isPlayer) {
						t = new Thread(new ActivateRedstone("door", args[0], player.getWorld()));
					} else {
						t = new Thread(new ActivateRedstone("door", args[0], this.getServer().getWorlds().get(0)));
					}
					t.start();
					if(args[0].equalsIgnoreCase("red") || args[0].equalsIgnoreCase("yellow") || args[0].equalsIgnoreCase("green") || args[0].equalsIgnoreCase("blue")) {
						broadcast(ChatColor.GRAY+"New door chosen: "+args[0]);
						log("New door chosen: "+args[0]);
					} else {
						broadcast(ChatColor.GRAY+"All doors closed");
						log("All doors closed");
					}
					return true;
				}
			} else {
				return false;
			}
		}
		return false;
	}
	
	//TODO: REMOVE Thread
	private static class ActivateRedstone implements Runnable {
		Block block;
		Material from;
		String action;
		String door;
		World world;
		public ActivateRedstone(String action, Block block) {
			this.block = block;
			this.from = block.getType();
			this.action = action;
		}
		public ActivateRedstone(String action, String door, World world) {
			this.action = action;
			this.door = door;
			this.world = world;
		}
		public void run() {
			if(action.equalsIgnoreCase("plate")) {
				block.setType(Material.REDSTONE_TORCH_ON);
				try {
					Thread.sleep(2000);
				} catch (InterruptedException e) {
					block.setType(from);
					e.printStackTrace();
				}
				block.setType(from);
			} else if(action.equalsIgnoreCase("door")) {
				Block redOn = world.getBlockAt(-11, 14, 633);
				Block yellowOn = world.getBlockAt(-11, 14, 627);
				Block greenOn = world.getBlockAt(-11, 14, 639);
				Block blueOn = world.getBlockAt(-11, 14, 645);
				Block redOff = world.getBlockAt(-10, 14, 634);
				Block yellowOff = world.getBlockAt(-10, 14, 628);
				Block greenOff = world.getBlockAt(-10, 14, 640);
				Block blueOff = world.getBlockAt(-10, 14, 646);
				if(door.equalsIgnoreCase("red")) {
					redOff.setType(Material.AIR);
					yellowOn.setType(Material.AIR);
					greenOn.setType(Material.AIR);
					blueOn.setType(Material.AIR);
					try {
						Thread.sleep(1000);
					} catch (InterruptedException e) {
						redOff.setType(Material.REDSTONE_TORCH_OFF);
						redOff.setData((byte) 3);
						yellowOn.setType(Material.REDSTONE_TORCH_OFF);
						yellowOn.setData((byte) 4);
						greenOn.setType(Material.REDSTONE_TORCH_OFF);
						greenOn.setData((byte) 4);
						blueOn.setType(Material.REDSTONE_TORCH_OFF);
						e.printStackTrace();
					}
					redOff.setType(Material.REDSTONE_TORCH_OFF);
					redOff.setData((byte) 3);
					yellowOn.setType(Material.REDSTONE_TORCH_OFF);
					yellowOn.setData((byte) 4);
					greenOn.setType(Material.REDSTONE_TORCH_OFF);
					greenOn.setData((byte) 4);
					blueOn.setType(Material.REDSTONE_TORCH_OFF);
					blueOn.setData((byte) 4);
				} else if(door.equalsIgnoreCase("yellow")) {
					redOn.setType(Material.AIR);
					yellowOff.setType(Material.AIR);
					greenOn.setType(Material.AIR);
					blueOn.setType(Material.AIR);
					try {
						Thread.sleep(1000);
					} catch (InterruptedException e) {
						redOn.setType(Material.REDSTONE_TORCH_OFF);
						redOn.setData((byte) 4);
						yellowOff.setType(Material.REDSTONE_TORCH_OFF);
						yellowOff.setData((byte) 3);
						greenOn.setType(Material.REDSTONE_TORCH_OFF);
						greenOn.setData((byte) 4);
						blueOn.setType(Material.REDSTONE_TORCH_OFF);
						blueOn.setData((byte) 4);
						e.printStackTrace();
					}
					redOn.setType(Material.REDSTONE_TORCH_OFF);
					redOn.setData((byte) 4);
					yellowOff.setType(Material.REDSTONE_TORCH_OFF);
					yellowOff.setData((byte) 3);
					greenOn.setType(Material.REDSTONE_TORCH_OFF);
					greenOn.setData((byte) 4);
					blueOn.setType(Material.REDSTONE_TORCH_OFF);
					blueOn.setData((byte) 4);
				} else if(door.equalsIgnoreCase("green")) {
					redOn.setType(Material.AIR);
					yellowOn.setType(Material.AIR);
					greenOff.setType(Material.AIR);
					blueOn.setType(Material.AIR);
					try {
						Thread.sleep(1000);
					} catch (InterruptedException e) {
						redOn.setType(Material.REDSTONE_TORCH_OFF);
						redOn.setData((byte) 4);
						yellowOn.setType(Material.REDSTONE_TORCH_OFF);
						yellowOn.setData((byte) 4);
						greenOff.setType(Material.REDSTONE_TORCH_OFF);
						greenOff.setData((byte) 3);
						blueOn.setType(Material.REDSTONE_TORCH_OFF);
						blueOn.setData((byte) 4);
						e.printStackTrace();
					}
					redOn.setType(Material.REDSTONE_TORCH_OFF);
					redOn.setData((byte) 4);
					yellowOn.setType(Material.REDSTONE_TORCH_OFF);
					yellowOn.setData((byte) 4);
					greenOff.setType(Material.REDSTONE_TORCH_OFF);
					greenOff.setData((byte) 3);
					blueOn.setType(Material.REDSTONE_TORCH_OFF);
					blueOn.setData((byte) 4);
				} else if(door.equalsIgnoreCase("blue")) {
					redOn.setType(Material.AIR);
					yellowOn.setType(Material.AIR);
					greenOn.setType(Material.AIR);
					blueOff.setType(Material.AIR);
					try {
						Thread.sleep(1000);
					} catch (InterruptedException e) {
						redOn.setType(Material.REDSTONE_TORCH_OFF);
						redOn.setData((byte) 4);
						yellowOn.setType(Material.REDSTONE_TORCH_OFF);
						yellowOn.setData((byte) 4);
						greenOn.setType(Material.REDSTONE_TORCH_OFF);
						greenOn.setData((byte) 4);
						blueOff.setType(Material.REDSTONE_TORCH_OFF);
						blueOff.setData((byte) 3);
						e.printStackTrace();
					}
					redOn.setType(Material.REDSTONE_TORCH_OFF);
					redOn.setData((byte) 4);
					yellowOn.setType(Material.REDSTONE_TORCH_OFF);
					yellowOn.setData((byte) 4);
					greenOn.setType(Material.REDSTONE_TORCH_OFF);
					greenOn.setData((byte) 4);
					blueOff.setType(Material.REDSTONE_TORCH_OFF);
					blueOff.setData((byte) 3);
				} else {
					redOn.setType(Material.AIR);
					yellowOn.setType(Material.AIR);
					greenOn.setType(Material.AIR);
					blueOn.setType(Material.AIR);
					try {
						Thread.sleep(1000);
					} catch (InterruptedException e) {
						redOn.setType(Material.REDSTONE_TORCH_OFF);
						redOn.setData((byte) 4);
						yellowOn.setType(Material.REDSTONE_TORCH_OFF);
						yellowOn.setData((byte) 4);
						greenOn.setType(Material.REDSTONE_TORCH_OFF);
						greenOn.setData((byte) 4);
						blueOn.setType(Material.REDSTONE_TORCH_OFF);
						blueOn.setData((byte) 4);
						e.printStackTrace();
					}
					redOn.setType(Material.REDSTONE_TORCH_OFF);
					redOn.setData((byte) 4);
					yellowOn.setType(Material.REDSTONE_TORCH_OFF);
					yellowOn.setData((byte) 4);
					greenOn.setType(Material.REDSTONE_TORCH_OFF);
					greenOn.setData((byte) 4);
					blueOn.setType(Material.REDSTONE_TORCH_OFF);
					blueOn.setData((byte) 4);
				}
			}
		}
	}
	
}