package com.atomicriot.pinacoladaxb.HideAndSeek;

import org.bukkit.ChatColor;
import org.bukkit.entity.Player;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.EntityListener;
import org.bukkit.event.entity.ItemSpawnEvent;


/**
 * HideAndSeek entity listener
 * @author pinacoladaxb
 */
public class HideAndSeekEntityListener extends EntityListener {
    private final HideAndSeek plugin;

    public HideAndSeekEntityListener(final HideAndSeek plugin) {

        this.plugin = plugin;
    }
    public void onEntityDamage(EntityDamageEvent event) {
    	Player victim;
    	Player attacker;
    	if(!(event.getEntity() instanceof Player)) {
    		return; // Ignore if victim is not a player
    	}
		victim = (Player) event.getEntity(); // Set victim
		if(victim==plugin.seeker && plugin.gameState==1) {
			event.setDamage(0); // Cancel damage if seeker falling through web
		}
    	if(!(event instanceof EntityDamageByEntityEvent)) {
    		return; // Ignore if victim not damaged by entity
    	}
		EntityDamageByEntityEvent subEvent = (EntityDamageByEntityEvent) event;
		if(!(subEvent.getDamager() instanceof Player)) {
			return; // Ignore if victim not damaged by player
		}
		event.setDamage(0);
		if(plugin.gameState!=2) {
			return; // Ignore if seeker isn't seeking
		}
		attacker=(Player)subEvent.getDamager();
		if(attacker!=plugin.seeker) {
			return; // Ignore if attacker is not the seeker
		}
		if(plugin.getState(victim)==0) {
			if(plugin.countStates(2)==0) {
				plugin.nextSeeker = victim;
			}
			plugin.setState(victim, 2);
			plugin.broadcast(ChatColor.RED+attacker.getName()+ChatColor.GREEN+" found "+ChatColor.AQUA+victim.getName()+ChatColor.GREEN+" ("+plugin.countStates(0)+" left)");
			plugin.setWin(attacker, 1);
			plugin.setWin(victim, -1);
			if(plugin.countStates(0)==0) {
				plugin.nextRound();
			}
		}
    }
    
    //TODO: Remove from official release:
    public void onItemSpawn(ItemSpawnEvent event) {
    	event.setCancelled(true);
    }
}
