package com.atomicriot.pinacoladaxb.HideAndSeek;

import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.entity.Player;
import org.bukkit.event.player.PlayerJoinEvent;
import org.bukkit.event.player.PlayerListener;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.event.player.PlayerQuitEvent;
import org.bukkit.event.player.PlayerRespawnEvent;

/**
 * Handle events for all Player related events
 * @author pinacoladaxb
 */
public class HideAndSeekPlayerListener extends PlayerListener {
    private final HideAndSeek plugin;
    public HideAndSeekPlayerListener(HideAndSeek instance) {

        this.plugin = instance;
    }
    public void onPlayerMove(PlayerMoveEvent event) {
    	Player player = event.getPlayer();
    	
    	//Sneaking during game
    	if(plugin.gameState==0) {
    		player.setSneaking(false);
    	} else {
    		player.setSneaking(true);
    	}
        
    	Location location = player.getLocation();
    	
        //Compass pointing
    	
        if(plugin.gameState==2) {
        	if(!(plugin.winner.equals(plugin.seeker))) {
        		plugin.seeker.setCompassTarget((plugin.getWinner(plugin.seeker)).getLocation());
        	} else {
        		plugin.seeker.setCompassTarget(plugin.winner.getLocation());
        	}
        	
        	
        	/* Code for set target to closest player:
        	Location loc = null;
        	Location locTemp = null;
        	double distance = 0;
        	double distanceTemp = 0;
        	int test=0;
    		for(Player p:plugin.players) {
    			if(p!=plugin.seeker) {
	    			if(test==0) {
	    				loc = p.getLocation();
	    				distance=loc.distance(plugin.seeker.getLocation());
	    				test=1;
	    			} else {
	    				locTemp = p.getLocation();
	    				distanceTemp=locTemp.distance(plugin.seeker.getLocation());
	    				if(distanceTemp<distance) {
	    					loc = locTemp;
	    					distance=distanceTemp;
	    				}
	    			}
    			}
    		}
    		plugin.seeker.setCompassTarget(loc);
    		*/
        }
        
        //If player is hider, we're seeking, and player is a player, check if safe
        if(player!=plugin.seeker && plugin.gameState==2 &&plugin.players.contains(player)) {
        	if(plugin.isInBounds(location,plugin.safe1,plugin.safe2)) {
        		plugin.setState(player, 1);
    			plugin.broadcast(ChatColor.AQUA+player.getName()+ChatColor.GREEN+" is safe ("+plugin.countStates(0)+" left)");
    			plugin.setWin(player, 1);
    			if(plugin.countStates(0)==0) {
        			plugin.nextRound();
        		}
        	}
        }
        
        //If player is seeker and we're preping, check if in web
        if(player==plugin.seeker && plugin.gameState==0) {
        	if(plugin.isInBounds(location,plugin.count1,plugin.count2)) {
        		plugin.setState(plugin.seeker, 3);
        		plugin.gameState=1;
        		plugin.broadcast(ChatColor.RED+player.getName()+ChatColor.GREEN+" is counting! RUN!");
        		for(Player p:plugin.players) {
        			if(plugin.getState(p)==0 && !(plugin.isInBounds(p.getLocation(), plugin.safe1, plugin.safe2))) {
        				plugin.broadcast(ChatColor.AQUA+p.getName()+ChatColor.GREEN+" has been disqualified");
        				if(plugin.nextSeeker==plugin.seeker) plugin.nextSeeker=p;
        				plugin.setState(p, 1);
        			}
        		}
        	}
        }
        
        //If player is seeker and we're hiding, check if NOT in web
        if(player==plugin.seeker && plugin.gameState==1) {
        	if(!(plugin.isInBounds(location,plugin.count1,plugin.count2))) {
        		plugin.gameState=2;
        		plugin.getServer().broadcastMessage("<"+player.getDisplayName()+"> Ready or not, here I come!");
        		for(Player p:plugin.players) {
        			if(plugin.getState(p)==0 && plugin.isInBounds(p.getLocation(), plugin.dq1, plugin.dq2)) {
        				plugin.broadcast(ChatColor.AQUA+p.getName()+ChatColor.GREEN+" has been disqualified");
        				if(plugin.nextSeeker==plugin.seeker) plugin.nextSeeker=p;
        				plugin.setState(p, 1);
        			}
        		}
        		if(plugin.countStates(0)==0) {
        			plugin.nextRound();
        		}
        	}
        }
    }
    public void onPlayerJoin(PlayerJoinEvent event) {
    	if(plugin.seeker!=null) {
	    	plugin.players.add(event.getPlayer());
			plugin.playerStates.add(1);
			plugin.wins.add(0);
	    	if(plugin.gameState==0) {
	        	event.getPlayer().sendMessage("HideAndSeek: "+ChatColor.GREEN+" A new round with "+ChatColor.RED+plugin.seeker.getName()+ChatColor.GREEN+" as the seeker is about to begin");
	    	} else {
	    		event.setJoinMessage(event.getJoinMessage()+" (Not playing round)");
	        	event.getPlayer().sendMessage("HideAndSeek: "+ChatColor.GREEN+" You will be included in the next round");
	    	}
    	}
    }
    public void onPlayerQuit(PlayerQuitEvent event) {
    	if(plugin.seeker!=null) {
    		plugin.broadcast(ChatColor.GREEN + "The game has ended");
    	}
    	plugin.reset();
    	/* Code for using reload:
    	Player player=event.getPlayer();
    	if(plugin.players.contains(player)) {
    		int index = plugin.players.indexOf(player);
        	plugin.players.remove(index);
        	plugin.playerStates.remove(index);
        	if(plugin.seeker==player) {
        		if(plugin.nextSeeker!=player) {
        		} else {
        			plugin.nextSeeker=null;
        		}
    			plugin.nextRound();
        	}
        	if(plugin.countStates(0)==0) {
    			plugin.nextRound();
    		}
    	}
    	*/
    	//TODO: Add players left to quit message if in config
    }
    public void onPlayerRespawn(PlayerRespawnEvent event) {
    	if(plugin.gameState==2 && plugin.players.contains(event.getPlayer())) {
    		Player p=event.getPlayer();
    		plugin.broadcast(ChatColor.AQUA+p.getName()+ChatColor.GREEN+" has been disqualified");
			if(plugin.nextSeeker==plugin.seeker) plugin.nextSeeker=p;
			plugin.setState(p, 1);
			if(plugin.countStates(0)==0) {
    			plugin.nextRound();
    		}
    	}
    }
}